"""
    Basis Theory API

    ## Getting Started * Sign-in to [Basis Theory](https://basistheory.com) and go to [Applications](https://portal.basistheory.com/applications) * Create a Basis Theory Private Application * All permissions should be selected * Paste the API Key into the `BT-API-KEY` variable  # noqa: E501

    The version of the OpenAPI document: v1
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401

from basistheory.model_utils import (  # noqa: F401
    ApiTypeError,
    ModelComposed,
    ModelNormal,
    ModelSimple,
    cached_property,
    change_keys_js_to_python,
    convert_js_args_to_python_args,
    date,
    datetime,
    file_type,
    none_type,
    validate_get_composed_info,
    OpenApiModel
)
from basistheory.exceptions import ApiAttributeError


def lazy_import():
    from basistheory.model.three_ds_acs_rendering_type import ThreeDSAcsRenderingType
    from basistheory.model.three_ds_message_extension import ThreeDSMessageExtension
    globals()['ThreeDSAcsRenderingType'] = ThreeDSAcsRenderingType
    globals()['ThreeDSMessageExtension'] = ThreeDSMessageExtension


class ThreeDSAuthentication(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    Attributes:
      allowed_values (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          with a capitalized key describing the allowed value and an allowed
          value. These dicts store the allowed enum values.
      attribute_map (dict): The key is attribute name
          and the value is json key in definition.
      discriminator_value_class_map (dict): A dict to go from the discriminator
          variable value to the discriminator class name.
      validations (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          that stores validations for max_length, min_length, max_items,
          min_items, exclusive_maximum, inclusive_maximum, exclusive_minimum,
          inclusive_minimum, and regex.
      additional_properties_type (tuple): A tuple of classes accepted
          as additional properties values.
    """

    allowed_values = {
    }

    validations = {
        ('acs_transaction_id',): {
            'max_length': 36,
            'regex': {
                'pattern': r'^[0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[0-9a-fA-F]{4}-[0-9a-fA-F]{4}-[0-9a-fA-F]{12}$',  # noqa: E501
            },
        },
        ('ds_transaction_id',): {
            'max_length': 36,
            'regex': {
                'pattern': r'^[0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[0-9a-fA-F]{4}-[0-9a-fA-F]{4}-[0-9a-fA-F]{12}$',  # noqa: E501
            },
        },
        ('sdk_transaction_id',): {
            'max_length': 36,
            'regex': {
                'pattern': r'^[0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[0-9a-fA-F]{4}-[0-9a-fA-F]{4}-[0-9a-fA-F]{12}$',  # noqa: E501
            },
        },
    }

    additional_properties_type = None

    _nullable = False

    @cached_property
    def openapi_types():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded

        Returns
            openapi_types (dict): The key is attribute name
                and the value is attribute type.
        """
        lazy_import()
        return {
            'pan_token_id': (str, none_type,),  # noqa: E501
            'threeds_version': (str, none_type,),  # noqa: E501
            'acs_transaction_id': (str, none_type,),  # noqa: E501
            'ds_transaction_id': (str, none_type,),  # noqa: E501
            'sdk_transaction_id': (str, none_type,),  # noqa: E501
            'acs_reference_number': (str, none_type,),  # noqa: E501
            'ds_reference_number': (str, none_type,),  # noqa: E501
            'authentication_value': (str, none_type,),  # noqa: E501
            'authentication_status': (str, none_type,),  # noqa: E501
            'authentication_status_code': (str, none_type,),  # noqa: E501
            'authentication_status_reason': (str, none_type,),  # noqa: E501
            'eci': (str, none_type,),  # noqa: E501
            'acs_challenge_mandated': (str, none_type,),  # noqa: E501
            'acs_decoupled_authentication': (str, none_type,),  # noqa: E501
            'authentication_challenge_type': (str, none_type,),  # noqa: E501
            'acs_rendering_type': (ThreeDSAcsRenderingType,),  # noqa: E501
            'acs_signed_content': (str, none_type,),  # noqa: E501
            'acs_challenge_url': (str, none_type,),  # noqa: E501
            'challenge_attempts': (str, none_type,),  # noqa: E501
            'challenge_cancel_reason': (str, none_type,),  # noqa: E501
            'cardholder_info': (str, none_type,),  # noqa: E501
            'whitelist_status': (str, none_type,),  # noqa: E501
            'whitelist_status_source': (str, none_type,),  # noqa: E501
            'message_extensions': ([ThreeDSMessageExtension], none_type,),  # noqa: E501
        }

    @cached_property
    def discriminator():
        return None


    attribute_map = {
        'pan_token_id': 'pan_token_id',  # noqa: E501
        'threeds_version': 'threeds_version',  # noqa: E501
        'acs_transaction_id': 'acs_transaction_id',  # noqa: E501
        'ds_transaction_id': 'ds_transaction_id',  # noqa: E501
        'sdk_transaction_id': 'sdk_transaction_id',  # noqa: E501
        'acs_reference_number': 'acs_reference_number',  # noqa: E501
        'ds_reference_number': 'ds_reference_number',  # noqa: E501
        'authentication_value': 'authentication_value',  # noqa: E501
        'authentication_status': 'authentication_status',  # noqa: E501
        'authentication_status_code': 'authentication_status_code',  # noqa: E501
        'authentication_status_reason': 'authentication_status_reason',  # noqa: E501
        'eci': 'eci',  # noqa: E501
        'acs_challenge_mandated': 'acs_challenge_mandated',  # noqa: E501
        'acs_decoupled_authentication': 'acs_decoupled_authentication',  # noqa: E501
        'authentication_challenge_type': 'authentication_challenge_type',  # noqa: E501
        'acs_rendering_type': 'acs_rendering_type',  # noqa: E501
        'acs_signed_content': 'acs_signed_content',  # noqa: E501
        'acs_challenge_url': 'acs_challenge_url',  # noqa: E501
        'challenge_attempts': 'challenge_attempts',  # noqa: E501
        'challenge_cancel_reason': 'challenge_cancel_reason',  # noqa: E501
        'cardholder_info': 'cardholder_info',  # noqa: E501
        'whitelist_status': 'whitelist_status',  # noqa: E501
        'whitelist_status_source': 'whitelist_status_source',  # noqa: E501
        'message_extensions': 'message_extensions',  # noqa: E501
    }

    read_only_vars = {
    }

    _composed_schemas = {}

    @classmethod
    @convert_js_args_to_python_args
    def _from_openapi_data(cls, *args, **kwargs):  # noqa: E501
        """ThreeDSAuthentication - a model defined in OpenAPI

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            pan_token_id (str, none_type): [optional]  # noqa: E501
            threeds_version (str, none_type): [optional]  # noqa: E501
            acs_transaction_id (str, none_type): [optional]  # noqa: E501
            ds_transaction_id (str, none_type): [optional]  # noqa: E501
            sdk_transaction_id (str, none_type): [optional]  # noqa: E501
            acs_reference_number (str, none_type): [optional]  # noqa: E501
            ds_reference_number (str, none_type): [optional]  # noqa: E501
            authentication_value (str, none_type): [optional]  # noqa: E501
            authentication_status (str, none_type): [optional]  # noqa: E501
            authentication_status_code (str, none_type): [optional]  # noqa: E501
            authentication_status_reason (str, none_type): [optional]  # noqa: E501
            eci (str, none_type): [optional]  # noqa: E501
            acs_challenge_mandated (str, none_type): [optional]  # noqa: E501
            acs_decoupled_authentication (str, none_type): [optional]  # noqa: E501
            authentication_challenge_type (str, none_type): [optional]  # noqa: E501
            acs_rendering_type (ThreeDSAcsRenderingType): [optional]  # noqa: E501
            acs_signed_content (str, none_type): [optional]  # noqa: E501
            acs_challenge_url (str, none_type): [optional]  # noqa: E501
            challenge_attempts (str, none_type): [optional]  # noqa: E501
            challenge_cancel_reason (str, none_type): [optional]  # noqa: E501
            cardholder_info (str, none_type): [optional]  # noqa: E501
            whitelist_status (str, none_type): [optional]  # noqa: E501
            whitelist_status_source (str, none_type): [optional]  # noqa: E501
            message_extensions ([ThreeDSMessageExtension], none_type): [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', True)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        self = super(OpenApiModel, cls).__new__(cls)

        if args:
            for arg in args:
                if isinstance(arg, dict):
                    kwargs.update(arg)
                else:
                    raise ApiTypeError(
                        "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                            args,
                            self.__class__.__name__,
                        ),
                        path_to_item=_path_to_item,
                        valid_classes=(self.__class__,),
                    )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
        return self

    required_properties = set([
        '_data_store',
        '_check_type',
        '_spec_property_naming',
        '_path_to_item',
        '_configuration',
        '_visited_composed_classes',
    ])

    @convert_js_args_to_python_args
    def __init__(self, *args, **kwargs):  # noqa: E501
        """ThreeDSAuthentication - a model defined in OpenAPI

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            pan_token_id (str, none_type): [optional]  # noqa: E501
            threeds_version (str, none_type): [optional]  # noqa: E501
            acs_transaction_id (str, none_type): [optional]  # noqa: E501
            ds_transaction_id (str, none_type): [optional]  # noqa: E501
            sdk_transaction_id (str, none_type): [optional]  # noqa: E501
            acs_reference_number (str, none_type): [optional]  # noqa: E501
            ds_reference_number (str, none_type): [optional]  # noqa: E501
            authentication_value (str, none_type): [optional]  # noqa: E501
            authentication_status (str, none_type): [optional]  # noqa: E501
            authentication_status_code (str, none_type): [optional]  # noqa: E501
            authentication_status_reason (str, none_type): [optional]  # noqa: E501
            eci (str, none_type): [optional]  # noqa: E501
            acs_challenge_mandated (str, none_type): [optional]  # noqa: E501
            acs_decoupled_authentication (str, none_type): [optional]  # noqa: E501
            authentication_challenge_type (str, none_type): [optional]  # noqa: E501
            acs_rendering_type (ThreeDSAcsRenderingType): [optional]  # noqa: E501
            acs_signed_content (str, none_type): [optional]  # noqa: E501
            acs_challenge_url (str, none_type): [optional]  # noqa: E501
            challenge_attempts (str, none_type): [optional]  # noqa: E501
            challenge_cancel_reason (str, none_type): [optional]  # noqa: E501
            cardholder_info (str, none_type): [optional]  # noqa: E501
            whitelist_status (str, none_type): [optional]  # noqa: E501
            whitelist_status_source (str, none_type): [optional]  # noqa: E501
            message_extensions ([ThreeDSMessageExtension], none_type): [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        if args:
            for arg in args:
                if isinstance(arg, dict):
                    kwargs.update(arg)
                else:
                    raise ApiTypeError(
                        "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                            args,
                            self.__class__.__name__,
                        ),
                        path_to_item=_path_to_item,
                        valid_classes=(self.__class__,),
                    )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
            if var_name in self.read_only_vars:
                raise ApiAttributeError(f"`{var_name}` is a read-only attribute. Use `from_openapi_data` to instantiate "
                                     f"class with read only attributes.")
